unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, system.Diagnostics;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    X_Edit: TLabeledEdit;
    PrecisionEdit: TLabeledEdit;
    calc_Btn: TBitBtn;
    clearBtn: TBitBtn;
    Hype_Edit: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    Hype_Btn: TBitBtn;
    TimeEdit: TLabeledEdit;
    procedure calc_BtnClick(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure Hype_BtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses exp_sub, Velthuis.Bigdecimals, Velthuis.bigintegers;

// L
function InPrecision(s: string; m: integer): integer;
var
  ch : integer;
begin
  val(s, Result, ch);
  if ch <> 0 then begin
    application.MessageBox('LɊԈႢ܂B','',0);
    result := -1;
    exit;
  end;
  if Result < 1 then begin
    application.MessageBox('L͂PȏɂĂB','',0);
  end;
  if m = 0 then begin
    if Result > 5000 then begin
      application.MessageBox('L5000ɂĂB','',0);
      result := -1;
    end;
  end
  else
    if Result > 50000 then begin
      application.MessageBox('L50000ɂĂB','',0);
      result := -1;
    end;
end;

// w̖ꍇ̐lmF
// x:  'e','E'̂Ȃ
// ca:  0 '.' ꍇ@1 Ȃꍇ
// 肪ꍇ 0Ԃ܂
function numeralfloatcheck(x: string; ca: byte): integer;
var
  len, dn, n, d : integer;
  num, numb : string;
  flg : boolean;
  snum : integer;
begin
  len := length(x);                   // 
  snum := 1;
  num := x[1];                        // P
  dn := 0;
  flg := true;
  if num = '+' then inc(snum);          // '+' pX
  if num = '-' then inc(snum);          // '-' pX
  if num = '.' then begin               // '.'
    inc(dn);                            // '.'JEgCNg
    inc(snum);                          // pX
  end;
  for n := snum to len do begin       // snum len lmF
    num := x[n];
    if num = '.' then begin             // '.'
      inc(dn);                          // '.'JEgCNg
      continue;                         // pX
    end;
    flg := false;
    for d := 0 to 9 do begin            // 0`9̒lmF
      numb := inttostr(d);
      if numb = num then begin
        flg := true;
        break;
      end;
    end;
    if flg = false then break;
  end;
  if ca = 0 then begin                // '.'
    if dn > 1 then flg := false;        // '.'1Ȃ0k
  end
  else                                // '.'
    if dn > 0 then flg := false;        // '.'MG

  if flg then result := 0
         else result := 1;
end;

// ͊mF
function incheck(s, m: string): boolean;
const
  ec = 'e';
  eo = 'E';
  dt = '.';
var
  fs, es : string;
  ch, p, po, leng : integer;
begin
  result := false;
  p := pos(ec, s);             // 'e' ̈ʒu
  po := pos(eo, s);            // 'E' ̈ʒu
  p := p + po;
  if p = 0 then begin          // 'e'  'E' 
    ch := numeralfloatcheck(s, 0);    // '.'ŊmFĂǂ
    if ch <> 0 then begin
      application.MessageBox(' ͒lɊԈႢ܂B','',0);
      exit;
    end;
    result := true;
    exit;
  end;
  leng := length(s);
  fs := '';
  fs := copy(s, 1, p - 1);            // 'e'̑O̕o
  es := '';
  es := copy(s, p + 1, leng - p);     // 'e'̌̕o
  ch := numeralfloatcheck(fs, 0);     // 'e'̑O̊̕mF '.'ŊmFĂǂ
  if ch <> 0 then begin
    application.MessageBox(' ͒lɊԈႢ܂B','',0);
    exit;
  end;
  if es <> '' then begin              // 'e'̌̕mF
    ch := numeralfloatcheck(es, 1);   // '.'ŊmF
    if ch <> 0 then begin
      application.MessageBox(' ͒lɊԈႢ܂B','',0);
      exit;
    end;
  end;
  result := true;
end;

procedure TForm1.Hype_BtnClick(Sender: TObject);
var
  Precision : integer;
  x, ans : bigdecimal;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
  k : integer;
begin
  if not incheck(X_Edit.Text, 'oȐX') then exit;
  Precision := InPrecision(PrecisionEdit.Text, 0);   // L
  if Precision < 1 then exit;
  BigDecimal.DefaultPrecision := Precision;
  x := Hype_Edit.Text;
  StopWatch := TStopwatch.StartNew;

  k := radioGroup1.ItemIndex;
  ans := hyperbolic(x, k);

  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Timeedit.text := intTostr(ElapsedMillseconds) + 'msec';

  memo1.Lines.Append(ans.ToString);
end;

procedure TForm1.calc_BtnClick(Sender: TObject);
var
  Precision : integer;
  x, ans : bigdecimal;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
begin
  if not incheck(X_Edit.Text, 'wX') then exit;
  Precision := InPrecision(PrecisionEdit.Text, 0);   // L
  if Precision < 1 then exit;
  BigDecimal.DefaultPrecision := Precision;
  x := X_Edit.Text;
  StopWatch := TStopwatch.StartNew;
  ans := exp_big(x);

  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Timeedit.text := intTostr(ElapsedMillseconds) + 'msec';

  memo1.Lines.Append(ans.ToString);
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
  memo1.Clear;
end;

end.
